/* *****************************************************************
 * Auto WGet Daemon Private Plugin 0.1 alpha 2
 * Copyright (C) 2001 by Ilfat Kutdusov 2:5080/52@fidonet,
 *                                      DarkElf@os2.ru
 * ***************************************************************** */

PluginVer = '0.1.3'

/*
0.1.3 ࠢ ⮭   ७ ६.
0.1.2 ࠢ ஢
0.1.1 뢮  ᪠稢 䠩 (⪫砥)
0.1.0  饬- ᮧ   ࠡ  Classic  Object REXX 
*/

/* *****************************************************************
     ਭ   AWGetD  ᮥ 
    SysBar Pipe Monitor 뢮    ᪠稢 䠩
     ࠡ 室 AWGet ᨨ 1.6.1  .
   , ᮡ⢥, SysBar Pipe Monitor - ᨨ 
   (   ᡠ  ন ).
    %ETC%\AWGet.cfg 室  ᫥饥:

# ******************************************************************
#   ਭ   AWGetD  ᮥ 
#  SysBar Pipe Monitor 뢮    ᪠稢 䠩

PRIVATE_PLUGIN = D:\Util\AWGet\Plugins\SysPipe.cmd

# ଠ   SysBar-
#   ந ᫥騬 ࠧ: SYSBAR_PIPE || Number.
# .. 1- wget 㤥 饭   \pipe\WGet1
#      2-          -- || --           \pipe\WGet2
#  ⠪ . ᨬ DOWNLOADS_SIMULTANEOUSLY
# ᫨   ( ਭ )  뢮 㤥 ஢.
#  㬮砭: '\pipe\WGet'

SYSBAR_PIPE = \pipe\WGet

#   .   ଠ樮  室 ⥬,  㤥 - ࠢ
#  ਬ -  :-)
#  㬮砭: PathPlugin'\SysBar.log'

SYSBAR_PIPE_LOG = D:\Util\AWGet\Plugins\SysBar_Pipe.log

#   뢮  N .  祭 ਤ 㢥   
#   易  ⥬     - 樮.    
#    ॥ 祬    ਭ.  ᫨ 㦭 筮  뢮  ...
#  㬮砭: 5

SYSBAR_PART = 5

#   뢮  ᪠稢 䠩   - 뢮
#  㬮砭: 1 (뢮)

SYSBAR_FNAME = 1

# ******************************************************************

    ࣠  SysBar   ,  ਬ, 
   \pipe\wget1, \pipe\wget2, ....
     ࣠뢠    sysbar-  ᪮쪨, 
   ᪫뢠   ⮯   㣨

 * ***************************************************************** */

globals = "job."

parse source dir;
parse var dir x1 x2 dir;

part=5
Max_WGets = 5
channelp = '\pipe\WGet'
timeout=250 /*1/4 sec.*/
fname =''
outname=0

NameScript=filespec("name", dir)

LogFile = 'D:\Util\AWGet\Plugins\SysBar_Pipe.log'

s=''
Count=0

job.open_read  = "OPEN READ"
job.open_write = "OPEN WRITE"

if version = "OBJREXX" then do
   job.open_read  = "OPEN READ  SHAREREAD"
   job.open_write = "OPEN WRITE SHAREREAD"
end

 Signal ON notready
 Signal ON Syntax
 Signal ON Halt


do forever
  parse value linein() with event +4 +1 info

  select
    when event == "INIT" then do
       call JobRead info

       job.config_file = value( "ETC",, "OS2ENVIRONMENT" )"\awget.cfg"
 
       rc = stream( job.config_file, "C", job.open_read )

       do while lines(job.config_file) > 0
          parse value linein(job.config_file) with command "=" argument
          command  = translate(strip(command))
          argument = strip(argument)

          select
             when command == "DOWNLOADS_SIMULTANEOUSLY" then do
                Max_WGets = argument
             end
             when command == "SYSBAR_PIPE" then do
                channelp = argument
             end
             when command == "SYSBAR_PIPE_LOG" then do
                LogFile = argument
             end
             when command == "SYSBAR_PART" then do
                part = argument
             end
             when command == "SYSBAR_FNAME" then do
                outname = argument
             end

             otherwise 
          end
       end

       rc = stream( job.config_file, "C", "CLOSE" )

  LogLine = '+ ⢮ WGet-' Max_WGets
  Call WriteLog
  LogLine = '+  䠩' LogFile
  Call WriteLog
  LogLine = '+   ' channelp
  Call WriteLog
  LogLine = '+ 뢮  䠩' outname
  Call WriteLog

       do p=1 to Max_WGets
         semname='\SEM32\WGet'||p
  LogLine = '+ Semaphore name' semname
  Call WriteLog
         semhandle=SysCreateMutexSem(semname)
  LogLine = '+ Handle:' semhandle
  Call WriteLog
         if semhandle='' then  do
  LogLine = '! Can not create' semname
  Call WriteLog
         end
         rcc=SysOpenMutexSem(semhandle)
         if rcc<>0 then  do
  LogLine = '! Another error' semhandle '#rc='rcc
  Call WriteLog
         end
         rcc=SysRequestMutexSem(semhandle,timeout)
         if rcc==640 then iterate
         if rcc<>0 then do
  LogLine = '! Another error' semhandle '#rc='rcc
  Call WriteLog
         end
         leave
      end
        channel=channelp || p

        parse version version .
        if version == "OBJREXX" then
           call stream channel, 'c', 'open write nobuffer'
        else
           call stream channel, 'c', job.open_write

      call lineout, "DONE SysBar PLUGIN version" PluginVer "is activated with pipe" channel
      LogLine = "+ Pipe" channel
      Call WriteLog

    end

    when event == "STOP" then do
       call JobRead info
       call lineout, "DONE SysBar PLUGIN is stopped"
       call stream channel, 'c', 'close'
  LogLine = '+ Stoped'
  Call WriteLog
       exit 0
    end

    when event == "DATA" then do
       call lineout, "DONE"
  LogLine = '+ Start exchange data'
  Call WriteLog

       do forever
/* *********************************************************************** */
   c=charin()
   if c2d(c)==10 then do
      w1 = subword( s, 1, 1)
      w2 = subword( s, 2, 1)

      select
        when w1 == '=>' then do
          if \(outname==0) then do
             fname = substr(s, lastpos("/", s)+1, lastpos("'", s)-lastpos("/", s)-1 )':'
  LogLine = '+ 稢 䠩:' substr(s, lastpos("/", s)+1, lastpos("'", s)-lastpos("/", s)-1 )
  Call WriteLog
          end
        end
        when w1 == 'Connecting' then do
           w2 = subword( s, words(s), 1)
           if w2=='connected!' then
              call lineout channel, fname 'Connected'
           else
             call lineout channel, fname 'Connecting'
        end
        when w1 == 'Logging' then do
           w2 = subword( s, words(s), 1)
           if w2=='Logged' then
              call lineout channel, fname 'Logging'
           else
              call lineout channel, fname 'Logged'
        end
        when w1 == 'Length:' then do
           if \(w==0) then
              w = 0;
           call lineout channel, fname w'k'
        end   
        when w1 == '==>' then do
          if \(wordpos( 'REST', s)==0) then do
             w=0
             sbyte=subword(s,wordpos('REST', s)+1,1)
             if datatype(sbyte)=='NUM' then do
                w=sbyte%1024
                call lineout channel, fname w'k'
             end
          end
        end
      otherwise do
         a=1 
      end
      end
      if \(wordpos( 'saved', s )==0) then do
         parse var s st ' (' speed ')' other
         call lineout channel, fname speed
      end
      s =''; newline=0
   end
   else do
      s = s || c
      if (newline==0) & (pos('->',s)>0) then do
         newline=1
         w1 = subword( s, 1, 1)
         z = substr( w1, 1, length(w1)-1 )
         if datatype(z)=='NUM' then
            w = z
      end
      if (newline==1) & (c='.' | c=',') then do
         w=w+1
         if (w-(w%part)*part)==0 then
            call lineout channel, fname w'k'
      end
   end
/* *********************************************************************** */
          if c == '00'x then do
             leave
          end
       end
    end

    otherwise
       call lineout, "FAIL PLUGIN receives unknown event:" event info
  end
end

/* $Id: jobs.cms,v 1.6 2001/04/10 12:13:56 glass Exp $ */

/*------------------------------------------------------------------
 * Read Job from file
 *------------------------------------------------------------------*/
JobRead: procedure expose (globals) 

  parse arg pathname

  job.object               = ""
  job.url                  = ""
  job.download             = ""
  job.message_done         = ""
  job.message_error        = ""
  job.downloads_utility    = ""
  job.downloads_parameters = ""
  job.downloads_rc         = 0
  job.downloads_info       = ""

  rc = stream( pathname, "C", job.open_read ) 
  if rc \= "READY:" then do
     return 0
  end

  do while lines(pathname) > 0
     parse value linein(pathname) with command "=" argument

     command  = translate(strip(command))
     argument = strip(argument)

     select
        when command == "OBJECT",
           | command == "URL",
           | command == "DOWNLOAD",
           | command == "DOWNLOADS_UTILITY",
           | command == "DOWNLOADS_PARAMETERS",
           | command == "DOWNLOADS_SIMULTANEOUSLY",
           | command == "DOWNLOADS_RC",
           | command == "DOWNLOADS_INFO",
           | command == "MESSAGE_DONE",
           | command == "MESSAGE_ERROR" then

             job.command = argument
        otherwise
     end
  end

  rc = stream( pathname, "C", "CLOSE" )
return 1

/*------------------------------------------------------------------
 * Save Job to file
 *------------------------------------------------------------------*/
JobSave: procedure expose (globals)

  parse arg pathname

  if arg( 1, "omitted" ) | pathname == "" then do
     pathname = SysTempFileName( dir.jobs"\?????.job" )
     body.0   = 0
     end
  else do
     rc = stream( pathname, "C", job.open_read )

     do i = 1 while lines(pathname) > 0
        body.i = linein(pathname)
     end
     body.0 = i - 1
     rc = stream( pathname, "C", "CLOSE" )
  end

  key_list = "OBJECT "               ||,
             "URL "                  ||,
             "DOWNLOAD "             ||,
             "MESSAGE_DONE "         ||,
             "MESSAGE_ERROR "        ||,
             "DOWNLOADS_UTILITY "    ||,
             "DOWNLOADS_PARAMETERS " ||,
             "DOWNLOADS_RC "         ||,
             "DOWNLOADS_INFO "

  do i = 1 to words(key_list)
     key = word(key_list,i)

     do j = 1 to body.0
        if left( strip( body.j ), 1 ) == "#" then
           iterate

        parse value body.j with command "="
        command = translate(strip(command))

        if key == command then
           leave
     end j

     body.j = key "=" job.key

     if j > body.0 then
        body.0 = j
  end i

  if stream( pathname, "C", "QUERY EXISTS" ) \= "" then
     '@del "'pathname'" /F'

  rc = stream( pathname, "C", job.open_write )

  if rc \= "READY:" then do
     return ""
  end

  do j = 1 to body.0
     call lineout pathname, body.j
  end

  rc = stream( pathname, "C", "CLOSE" )
return pathname


Syntax:         /* ࠡ⪠ ᪫⥫ 権  訡  ணࠬ */
Halt:
  SS = SIGL
  Say '! 訡  ணࠬ' NameScript ' ப' SS'!'
  Say 'ப:' SourceLine(SS)
/*
  LogLine = '! 訡  ணࠬ' NameScript ' ப' SS'!'
  Call WriteLog
  LogLine = 'ப:' SourceLine(SS)
  Call WriteLog
*/
Return

WriteLog:
trace o
  if LogFile=='' then return
  L = Date( 'E' ) Time() LogLine
  call stream LogFile, 'c', job.open_write
  call LineOut LogFile, L
  call Stream LogFile , 'c', 'close' 
return

notready: exit 1



